const Promise = require('bluebird');

const Service = require('../service');

class MethodApi extends Service {
  get defaultOptions() {
    return {method: () => {
      throw new Error('Not implemented');
    }}
  }

  call(methodName, parameters, options) {
    const result = Promise.resolve(this.options.method(methodName, parameters, options));
    return result.then(result => {
      return {data: result, info: {}};
    });
  }
}

module.exports = MethodApi;
